// Autor:     Antonio Carrillo Ledesma.
// R.F.C.:    CALA-691229-TV5
// Direccin: Amsterdam 312 col. Hipodromo Condesa
// Telfono:  5-74-43-53

// Propiedad intelectual, todos los derechos reservados conforme a la ley, registro en trmite
// Revisin  1.0-A


#ifndef __man_arch_hpp__
#define __man_arch_hpp__

extern "C" {
   #include <stdio.h>
}   

#define LEE_ARCHIVO       0
#define GRABA_ARCHIVO     1
#define ADICIONA_ARCHIVO  2


// Clase manipuladora del manipulador de archivos
class Manipulador_archivos {
  private:

    char  MODO;                         // Guarda el modo de apertura del archivo
    char  ESTADO;                       // Variable que indica el estado del objeto
    FILE *ARCHIVO_TRABAJO;             // Puntero al archivo generado como reporte
    char car;                          // Variable de caracter temporal
    int  inttmp;                       // Variables temporal
    long longtmp;
    unsigned int uinttmp;
    unsigned char cartmp;
    const char *ARCHIVO;               // Nombre del archivo a trabajar
    const char *RUTINA;                // Nombre de la rutina que llama al manipulador de archivos
    char *DELIMITADOR;                 // Contiene el delimitador entre Lineas
    unsigned int  LG_MAX;              // Indica la longitud maxima de la cadena a trabajar


  public:

         // Costructor y destructor de la clase
         Manipulador_archivos(void);
        ~Manipulador_archivos();

         // Parametros para el manipulador de archivos
    void Parametros(const char *archivo, const int modo, const unsigned int lg_max, const char *rutina = "");
         // Cuenta el numero de caracteres y lineas dentro del archivo si T_P es (1) si T_P es (0) cuenta la cantidad de caracteres reales
	 void Longitud_archivo(long &lg_archivo, long &nm_lineas, const int t_p);
         // Lee la siguiente linea del archivo, retornando la longitud de la linea
	 long Lee_linea(char *cadena);
         // Graba una cadena como una linea del archivo, retornando la longitud de esta
    long Graba_linea(const char *cadena);
         // Se posiciona en la linea indicada por LINEA
	 long Busca_linea(const long linea);
         // Lee el numero de caracteres indicados en N_C y los deja en la cadena CADENA, retornando  el numero de caracteres leidos
	 long Lee_caracteres(char *cadena, const unsigned n_c);
         // Graba una una cadena de caracteres, retornando el numero de caracteres grabados
	 long Graba_caracteres(const char *cadena, const unsigned n_c);
         // Lee un entero
    void Lee_entero(int &num);
         // Lee un entero sin signo
    void Lee_entero(unsigned int &num);
         // Lee un carcater sin signo
    void Lee_caracter(char &num);
         // Lee un entero largo
    void Lee_entero_largo(long &num);
         // Lee un flotante double
    void Lee_double(double &num);
         // Integra::Graba un entero
    void Graba_entero(const int ent);
         // Graba un entero sin signo
    void Graba_entero(const unsigned int ent);
         // Graba un caracter sin signo
    void Graba_caracter(const char car);
         // Graba un entero largo
    void Graba_entero_largo(const long ent);
         // Graba un flotante double
    void Graba_double(const double num);
         // Debuelve el estado del manipulador de archivos
    int  Estado(void) const
         {return ESTADO;}
         // Posiciona al indicador del archivo en el inicio de este
    void Inicio_archivo(void)
         {ESTADO = 0; rewind(ARCHIVO_TRABAJO);}

};

#endif


