// Autor:     Antonio Carrillo Ledesma.
// R.F.C.:    CALA-691229-TV5
// Direccin: Amsterdam 312 col. Hipodromo Condesa
// Telfono:  5-74-43-53

// Propiedad intelectual, todos los derechos reservados conforme a la ley, registro en trmite
// Revisin  1.1-A


void Calendario(const int tp,const char *fecha);
  // Visualiza una ventana en la cual muestra el calendario del mes indicado por la cadena
  // de fecha pasada como parametro si tp es cero, si tp es distinto de cero asume la fecha 
  // actual del sistema



#include "v_iconos.hpp"
#include "nucleo.hpp"
#include "botontxt.hpp"
#include "r_var.hpp"
#include "cad_car.hpp"
#include "fechas.hpp"

// Objeto global al nuclo del sistema
extern Nucleo *NCO;
// Indica si el programa esta o no activo
extern int Programa_activo;



void Calendario(const int tp,const char *xfecha)
{
   unsigned int x1,y1,x2,y2,db = 1;
   int dias[50], n_md,ini,i,xi,xx;
   unsigned int mes, ano;
   char xcad[50], xcad1[50], xcad2[50], fecha[30];
   long  ct = 0, e_a = 1, st = 0;
   unsigned long jul = 0;
   if(tp) f_f_hoy(fecha);
    else strcpy(fecha,xfecha);
   mes = f_n_mes(fecha);
   ano = f_n_ano(fecha);

   Ventana_iconos *Vt = new Ventana_iconos;
   Vt->Activa_graba_ventana(1);
   Vt->Define_colores(Gris1,Rojo1,Gris9,Blanco);
   Vt->Cambia_tipo_letra_titulo(8,0,-1,0,0,0);
   Vt->Ventana_centrada("CALENDARIO",300,260,0);
   Vt->Dibuja();
   Vt->Actual_pos_ventana(x1,y1,x2,y2);
   Vt->Limpia_recuadro(10,45,290,180,Blanco,Negro,Negro);

   // Definicion del primer boton
   Boton_texto *Bt1 = new Boton_texto;
   Bt1->Define_boton("Anterior",x1 + 30,y2 - 30);
   Bt1->Dibuja();
   // Definicion del segundo boton
   Boton_texto *Bt2 = new Boton_texto;
   Bt2->Define_boton("Siguiente",x2 -114,y2 - 30);
   Bt2->Dibuja();

   // Visualiza la fecha actual
   Vt->Define_color(Blanco,Rojo9);
   f_fecha_escrita(fecha,xcad,1,1);
   Vt->Centra_texto(190,xcad);
   while(!ct) {
        if(db) {
           // Visualiza la ventana donde aparecera el calendario
           Vt->Limpia_recuadro(13,48,287,177,Blanco,Blanco,Blanco);
           // Visualiza el mes  y el ao
           f_mes_let(mes,xcad1,1);
           sprintf(xcad,"%s de %d",xcad1,ano);
           Vt->Define_color(Blanco,Rojo9);
           Vt->Centra_texto(70,xcad);
           Vt->Define_color(Blanco,Negro);
           Vt->Visualiza_texto(75,90,"D  L  M  M  J  V  S");
           Vt->Define_color(Blanco,Rojo1);
           // calcula el inicio del dia primero
           n_md = f_n_max_dias_mes(mes,ano);
           gregorian_julian(1,mes,ano,jul);
           ini = f_dia_sem(jul);
           // llena la table de los dias
           for(i = 0; i < 50; i++) dias[i] = 0;
           for(i = 0; i < n_md; i++) dias[ini + i] = dias[(i + ini)- 1] + 1;
           for(i = 0; i < 6; i++) {
               for(xi = 1; xi < 8; xi++) {
                 xx = xi + (i * 7);
                 sprintf(xcad2,"%d",dias[xx]);
                 // Visualiza los dias del mes
                 if(xx <= n_md + ini && dias[xx] > 0) Vt->Visualiza_texto(75+(((xi-1) * 3)*8),(11+i)*10,xcad2);
              }
           }
           db =0;
        }
        NCO->Administrador();
        // Revisa el estado de los botones
        if(Vt->Itera() || !Programa_activo) ct = 1;
        if(Bt1->Oprimido() || st == 1) {
            e_a = 1, mes--, db =1;
            if(!mes) mes = 12, ano--;
        }
        if(Bt2->Oprimido() || st == 2) {
            e_a = 2, mes++, db = 1;
            if(mes == 13) mes = 1, ano++;
        }
        // Actualiza el boton activo
        Bt1->Activar(e_a == 1);
        Bt2->Activar(e_a == 2);
        // Desactiva la salida por Esc
        if(ct == -1) ct = 0;
   }
   delete Bt1;
   delete Bt2;
   delete Vt;
}

