// Autor:     Antonio Carrillo Ledesma.
// R.F.C.:    CALA-691229-TV5
// Direccin: Amsterdam 312 col. Hipodromo Condesa
// Telfono:  5-74-43-53

// Propiedad intelectual, todos los derechos reservados conforme a la ley, registro en trmite
// Revisin  1.1-A


#include "cad_car.hpp"
extern "C" {
   #include <string.h>
}


int s_pos_palabra_ant(const char *cad, const long pos, const unsigned int t_p);
  // Retorna la posicion donde inicia la palabra anterior en la cadena CAD
  // a partir de la posicion POS hasta el inicio del archivo, retornando -1 si no se encuentra
  // Si T_P es (0) busca la palabra siguiente (alfanumerico sin espacio)
  //           (1) busca la palabra siguiente (alfanumerico con espacio)
  //           (2) Busca la palabra siguiente (numerico, punto y signo menos)
  //           (3) Busca la palabra siguiente (numerico)
  // Nombre del archivo: S_POSPLA.CPP



int s_pos_palabra_ant(const char *cad, const int pos, const unsigned int t_p)
{
   // Si esta al inicio de la cadena retorna -1
   if(!pos) return -1;
   int i = pos, sw = 1;
   if(i > strlen(cad)) i = strlen(cad) -1;
   // Busca la palabra anterior antes de los caracteres de espaciado
   while(cad[i] == 32 && i > 0) i--;
   // Busca donde inicia la palabra actual
   while(i > 0 && sw) {
      sw = 0;
      if(t_p == 0 && s_es_car_alfnum(cad[i]) &&  cad[i] != 32) sw = 1;
      if(t_p == 1 && s_es_car_alf(cad[i])) sw = 1;
      if(t_p == 2 && s_es_car_dig(cad[i])) sw = 1;
      if(t_p == 3 && s_es_car_num(cad[i])) sw = 1;
      i--;
   }
   return i;
}

