// Autor:     Antonio Carrillo Ledesma.
// R.F.C.:    CALA-691229-TV5
// Direccin: Amsterdam 312 col. Hipodromo Condesa
// Telfono:  5-74-43-53

// Propiedad intelectual, todos los derechos reservados conforme a la ley, registro en trmite
// Revisin  1.1-A

#include "cad_car.hpp"
extern "C" {
   #include <string.h>
}

int s_pos_palabra_sig(const char *cad, const int pos, const unsigned int t_p);
  // Retorna la posicion donde inicia la palabra siguiente en la cadena CAD
  // a partir de la posicion POS, retornando -1 si esta al final de la cadena
  // Si T_P es (0) busca la palabra siguiente (alfanumerico)
  //           (1) busca la palabra siguiente (alfanumerico con espacios)
  //           (2) Busca la palabra siguiente (numerico, punto, signo menos o mas)
  //           (3) Busca la palabra siguiente (numerico)
  // Nombre del archivo: S_POSPLS.CPP



int s_pos_palabra_sig(const char *cad, const int pos, const unsigned int t_p)
{
   // Revisa que la poscion no sea mayor que la longitud de la cadena
   if(pos > strlen(cad)) return -1;
   int i = pos, sw = 1;
   if(cad[i] == 32) {
      // Si empieza con espacios buscar el siguiente caracter distinto de estos y regrasara su posicion
      while(cad[i] == 32) i++;
    } else {
      // Busca hasta el final de la actual palabra
      while(cad[i] && sw) {
         sw = 0;
         if(!t_p && s_es_car_alfnum(cad[i]) &&  cad[i] != 32) sw = 1;
         if(t_p == 1 && s_es_car_alf(cad[i])) sw = 1;
         if(t_p == 2 && s_es_car_dig(cad[i])) sw = 1;
         if(t_p == 3 && s_es_car_num(cad[i])) sw = 1;
         i++;
      }
      while(cad[i] == 32) i++;
   }
   // Si es el final de la cadena retorna -1, en caso contrario regresa la posicin de la siguiente palabra
   if(!cad[i]) i = -1;
   return i;
}

