// Autor:     Antonio Carrillo Ledesma.
// R.F.C.:    CALA-691229-TV5
// Direccin: Amsterdam 312 col. Hipodromo Condesa
// Telfono:  5-74-43-53

// Propiedad intelectual, todos los derechos reservados conforme a la ley, registro en trmite
// Revisin  1.1-A


#include <string.h>
#include "pila.hpp"




// Constructor de la pila
PILA::PILA(unsigned int num_elementos_pila)
{
   // Inicializa el indicador de la pila
   Elemento_actual =0;
   // Define la longitud de la pila y el numero de elementos de esta
   NUM_ELEMENTOS_PILA = num_elementos_pila;
   // Solicita la memoria para la pila
   Bufer = new char *[NUM_ELEMENTOS_PILA+1];
   // Solicita la memoria para la cadena temporal de trabajo
   for(int i = 0; i < NUM_ELEMENTOS_PILA; i++) Bufer[i] = NULL;
}


// Destructor de la pila
PILA::~PILA()
{
   // Libera la memoria solicitada para la pila y la cadena de trabajo
   for(int i = 0; i < NUM_ELEMENTOS_PILA; i++) delete Bufer[i];
   delete[] Bufer;
}


// Mete la cadena en la pila
void PILA::Meter(const char *cadena)
{
   if(Elemento_actual <= NUM_ELEMENTOS_PILA) {
      xcad = new char[strlen(cadena)+1];
      strcpy(xcad,cadena);
      Bufer[Elemento_actual] = xcad;
      Elemento_actual ++;
   }
}


// Saca de la pila una cadena
void PILA::Sacar(char *cad)
{
   cad[0] = 0;
   if(Elemento_actual > 0) {
      Elemento_actual --;
      strcpy(cad,Bufer[Elemento_actual]);
      delete Bufer[Elemento_actual];
      Bufer[Elemento_actual] = NULL;
   }
}


