// Autor:     Antonio Carrillo Ledesma.
// R.F.C.:    CALA-691229-TV5
// Direccin: Amsterdam 312 col. Hipodromo Condesa
// Telfono:  5-74-43-53

// Propiedad intelectual, todos los derechos reservados conforme a la ley, registro en trmite
// Revisin  1.1-A


#ifndef __V_PIXEL_HPP__
#define __V_PIXEL_HPP__

// Definicin del pixel
struct Definicion_pixel {
   unsigned int pixel:1;
};


// Clase que manipila y controla un array de pixeles
class Arreglo_pixeles
{
   private:

      unsigned int       i1,i2;             // Variables temporales
      unsigned int       Num_Y;             // Longitud de la matriz en Y
      unsigned int       Num_X;             // Longitud de la matrix en X
      unsigned int       Activo:1;          // Indica si esta activo el objeto
      Definicion_pixel **Arreglo;           // Puntero al arreglo de pixeles

   public:
                     // Constructor de la clase
                     Arreglo_pixeles(void)
                     {Activo = 0;}
                     // Destructor de la clase
                    ~Arreglo_pixeles(void)
                     {Destruye();}
                     // Inicializa la clase
               void  Inicializa(const unsigned int pix_x, const unsigned int pix_y, const unsigned int val);
                     // Asigna a un pixel del arreglo el valor indicado
               void  Asigna_valor(const unsigned int pix_x, const unsigned int pix_y, const unsigned int val);
                     // Destruye el contenido del arreglo
               void  Destruye(void);
                     // Retorna el valor del pixel indicado dentro del arreglo
      unsigned int   Retorna_valor(const unsigned int pix_x, const unsigned int pix_y) const
                     {return Arreglo[pix_y][pix_x].pixel;}
                     // Asigna a todo el array el valor especificado
               void  Asigna_todo_array(const unsigned int val);
};


// Notas:
//   (1) El array empieza en cero para los pixeles Y y X
//   (2) El numero maximo de elemetos depende de la memoria de la maquina

#endif


